﻿//$reference Campaign.dll
//-$debug
using System;
using maddox.game;
using maddox.game.world;

public class Mission : maddox.game.campaign.Mission
{

    private void checkLanded(AiAircraft aircraft)
    {
        if (GamePlay.gpPlayer().Place() != aircraft)
            return;
	
        if (GamePlay.gpGetTrigger("trigger").Active)
        {
            if (Campaign != null)
            {
                if (Campaign.battleSuccess != null)
                    return;
                Campaign.battleSuccess = false;
            }
            GamePlay.gpHUDLogCenter("MISSION FAILED");
        }
	else 
	{
		if (Campaign != null)
            {
                if (Campaign.battleSuccess != null)
                    return;
                Campaign.battleSuccess = true;
            }
            GamePlay.gpHUDLogCenter("MISSION COMPLETE");
	}
    }

    public override void OnAircraftLanded(int missionNumber, string shortName, AiAircraft aircraft)
    {
        checkLanded(aircraft);
    }
}
