﻿//$reference Campaign.dll
//-$debug
using System;
using maddox.game;
using maddox.game.world;
using System.Collections.Generic;

public class Mission : maddox.game.campaign.Mission {

    AiActor a1, a2, a3;
    AiAircraft airc1, airc2, airc3;

    public override void OnBattleStarted() {
        base.OnBattleStarted();
        a1 = GamePlay.gpActorByName("0:BoB_RAF_F_602Sqn_Late.000");
        a2 = GamePlay.gpActorByName("0:BoB_RAF_F_602Sqn_Late.010");

        if (a1 == null || a2 == null) {
            System.Console.WriteLine("SCRIPR ERROR: Aircraft not found");
        }
        airc1 = (AiAircraft)a1;
        airc2 = (AiAircraft)a2;

    }


    public override void OnTrigger(int missionNumber, string shortName, bool active) {
        if ("trigger01".Equals(shortName) && active) {
            AiAction action = GamePlay.gpGetAction(ActorName.Full(missionNumber, shortName));
            if (action != null)
                action.Do();
            a3 = GamePlay.gpActorByName("1:BoB_LW_KG55_I.200");
            he111found = true;

            double initTime = 0.0;
            Timeout(initTime, () => {
                airc1.SayToGroup(airc2.AirGroup(), "Oh_God_this_is_the_most_romatic_thing_I_ve_Oh_Oooh_I_m");
            });
            Timeout(initTime += 5.0, () => {
                airc1.SayToGroup(airc2.AirGroup(), "Wait_what_s_that_Oh_another_plane_how_beautiful");
            });
            Timeout(initTime += 5.0, () => {
                airc2.SayToGroup(airc2.AirGroup(), "All_right_that_does_it_We_re_scrambling_A_flight_to_Oh_hell_");
            });
            Timeout(initTime += 5.0, () => {
                airc2.SayToGroup(airc2.AirGroup(), "Spitfire_pilot_you_Oh_he_s_going_for_the_Heinkel_Good_lord_H");
            });

            GamePlay.gpGetTrigger(shortName).Enable = false;
        }

        if ("trigger02".Equals(shortName) && active) { // взлет
            if (airc1.Person(0) != null &&
                airc1.Person(0).Health > 0.6) {
                double initTime = 0.0;
                Timeout(initTime, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Oh_my_God_Oh_my_God");
                });
                Timeout(initTime += 4.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "It_s_so_loud_oh_my_God");
                });
                Timeout(initTime += 5.0, () => {
                    airc2.SayToGroup(airc1.AirGroup(), "Who_s_in_that_Spitfire_Where_do_you_think_you_are_you_going_");
                });
                Timeout(initTime += 5.0, () => {
                    airc2.SayToGroup(airc1.AirGroup(), "What_in_the_blue_blazes_is_that_idiot_doing");
                });
                Timeout(initTime += 6.0, () => {
                    airc2.SayToGroup(airc1.AirGroup(), "Spitfire_pilot_you_will_abort_that_take_off_run_immediately_");
                });
                Timeout(initTime += 6.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Oh_God_we_re_going_so_fast");
                });
                Timeout(initTime += 4.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Oh_my_God_Stop_Please_stop_Ooooaaaaahhh");
                });
                Timeout(initTime += 5.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Spitfire_pilot_if_you_do_not_turn_around_and_land_right_bloo");
                });
                Timeout(initTime, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Oh_God_It_s_so_beautiful_Oh_I_think_I_m_in_heaven_I_am_in_he");
                });
                Timeout(initTime += 3.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Where_are_you_going_Blast_it_I_think_he_s_running_for_German");
                });
                Timeout(initTime += 3.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Spitfire_pilot_we_will_scramble_our_planes_and_notify_Archie");
                });
                Timeout(initTime += 3.0, () => {
                    airc1.SayToGroup(airc1.AirGroup(), "Return_to_base_immediately_or_you_will_be_shot_down_");
                });
            }
            GamePlay.gpGetTrigger(shortName).Enable = false;
        }
    }

    bool beforeAttack = false;
    bool dialog2 = false;
    bool he111found = false;
    public override void OnTickGame() {
        if (!beforeAttack && a3 != null) {
            if (a3 == null) {
                return;
            }
            airc3 = (AiAircraft)a3;
            AiAirGroupTask t = airc3.AirGroup().getTask();
            if (t == AiAirGroupTask.DO_NOTHING) {
                beforeAttack = true;
                if (airc1.Person(0) != null &&
                    airc1.Person(0).Health > 0.6) {
                    double initTime = 0.0;
                    Timeout(initTime, () => {
                        airc1.SayToGroup(airc1.AirGroup(), "Oh_you_ve_shot_him_down");
                    });
                    Timeout(initTime += 4.0, () => {
                        airc2.SayToGroup(airc1.AirGroup(), "Good_show_Spitfire_And_to_think_we_almost_Now_will_you_get_b");
                    });
                    Timeout(initTime += 8.0, () => {
                        airc2.SayToGroup(airc1.AirGroup(), "Was_that_an_enemy_plane_Why_did_you_Oh_the_flames_are_so_bri");
                    });
                }
            }
        }
        if (!dialog2 && airc1 != null) {
            AiAirGroupTask t = airc1.AirGroup().getTask();
            if (t == AiAirGroupTask.LANDING && airc1.Pos().z < 200.0) {
                dialog2 = true;
                if (airc1.Person(0) != null &&
                    airc1.Person(0).Health > 0.6) {
                    double initTime = 0.0;
                    Timeout(initTime, () => {
                        airc1.SayToGroup(airc1.AirGroup(), "Oooh_What_Stop_Ahhhhhh");
                    });
                    Timeout(initTime += 10.0, () => {
                        airc1.SayToGroup(airc1.AirGroup(), "Ooooh_my_Goooood_Ahhhh_Ooof");
                    });
                }
            }
        }
    }

    public override bool IsMissionListener(int missionNumber) {
        return true;
    }

    bool dialog1 = false;
    public override void OnAircraftDamaged(int missionNumber, string shortName, AiAircraft aircraft, AiDamageInitiator initiator, part.NamedDamageTypes damageType) {
        base.OnAircraftDamaged(missionNumber, shortName, aircraft, initiator, damageType);
        if (!dialog1 && aircraft.Army() == 2) {
            if (airc1.Person(0) != null &&
                airc1.Person(0).Health > 0.6) {
                    airc1.SayToGroup(airc1.AirGroup(), "Aaaaaaa_Oh_my_God_We_re_going_to_die_Oh_my_God");
            }
            dialog1 = true;
        }
    }

    int countDead = 0;
    public override void OnActorDead(int missionNumber, string shortName, AiActor actor, List<DamagerScore> initiatorList) {
        if (!(actor is AiAircraft))
            return;

        if (actor.Army() == 2) {
            if (GamePlay.gpPlayer().Place() != null) {
                countDead++;
                if (countDead != 1) {
                    return;
                }
                int personIndex = GamePlay.gpPlayer().PlacePrimary();
                if (personIndex < 0)
                    personIndex = GamePlay.gpPlayer().PlaceSecondary();
                AiPerson person = (GamePlay.gpPlayer().Place() as AiCart).Person(personIndex);
                if (person.Health <= 0)
                    return;
                if (Campaign != null) {
                    //
                    if (Campaign.battleSuccess != null)
                        return;
                    Campaign.battleSuccess = true;
                }
                GamePlay.gpHUDLogCenter("MISSION COMPLETE");
                if (airc1.Person(0) != null &&
                    airc1.Person(0).Health > 0.6) {
                    double initTime = 0.0;
                    Timeout(initTime, () => {
                        airc1.SayToGroup(airc1.AirGroup(), "Oooh_God_how_horrible");
                    });
                    Timeout(initTime += 4.0, () => {
                        airc2.SayToGroup(airc1.AirGroup(), "Spitfire_pilot_are_you_receiving_Rock_your_wingtips_if_you_d");
                    });
                    Timeout(initTime += 8.0, () => {
                        airc1.SayToGroup(airc1.AirGroup(), "What_s_that_voice_talking_Who_s_that");
                    });
                    Timeout(initTime += 4.0, () => {
                        airc2.SayToGroup(airc1.AirGroup(), "He_s_not_receiving_Well_just_watch_him_Get_everybody_ready_I");
                    });
                }
            }
        }
    }

}
